//this creates insane random shapes of random colors that "follow" the mouse
//and change when the mouse is pressed

//setup some variables
int gx;
int gy;

//setup the screen
void setup()
{
  size(600, 600);
  gx = width; 
  gy = height;
  size(gx, gy);
  strokeWeight(5);
  smooth();
  strokeJoin(ROUND);
  frameRate(30);
}

    //make a custom function that draws the insane shapes
    //note that it allows the input of position, scale and rotation from the caller
void drawCursor(float x, float y, float myscale, float myrot) {
        //push matrix is needed to apply transformations to the upcoming shape 
        //and must be ended with a pop matrix
  pushMatrix();
      //moves the new shape to these coordinates
  translate(x, y);
      //rotates the new shape
  rotate(myrot);
      //scales the new shape
  scale(myscale, myscale);
      //choose random color
  fill(random(200), random(200), random(200));
      //make a polygon using the vertices between this and endShape
  beginShape(POLYGON);
  //this for loop creates a random number of vertices and places them at locations randomly and according to the rotation
  for(int i = 0; i <= random(30); i++){
    //if the mouse is pressed, we use normal vetex, but if not, we use curve vertex
    if(mousePressed){
      vertex(myrot + i * random(-5, 5), random(100 * i));
    }
    else{
      curveVertex(myrot + i * random(-10, 10), random(60 * i));
    }
  }
  endShape();  
  popMatrix();
}

//redraw
void draw()
{
  //create motion trail with fading backdrop
 fill(0, 10);
 rect(0,0, width, height);
  stroke(.2,.2,.2);
  float rot;
  //two for loops create a screen full of shapes
  for (int i=16; i<gx+2; i+=62) {
    for (int j=11; j<gy; j+=60) {
      //rotate each shape according to the location of the cursor
      rot = -PI/4. + atan2(j-mouseY, i-mouseX);
      //call the drawCursor function to make the shapes, sending their coordinates, scale, and rotation
      drawCursor(i, j, 1, rot);
    }
  }  

}


