//this creates a screen of ellipses 
//whose size and color change as they become nearer to the cursor
//and also pulses in waves using cos()

//declare variables we will use below
float maxDistance;
float diameter = 60;
float mouseDist;
float k = 0;


//setup our screen and the styles for drawing
void setup() {
  size(400, 400);
  //noStroke();
  smooth();
  fill(0);
  frameRate(30);
  //the dist() finds the distance between two points, 
  //here we find the distance to the middle of the screen from the origin
  maxDistance = dist(0, 0, width/4, height/4);
}

//redraw everything on the screen as fast as the framerate dictates
void draw() {
//replace the last frame with a blank background 
  background(204);
  //iterate k from 0-360 in radians i.e. 0-2pi and then reset
  if (k <= 6.28){
    k += .05;
  }
  else{
    k=0;
  }
  //here we draw a grid of ellipses where i is for the x axis and j for the y axis
  for (float i = 0; i <= width; i += 20) {
    for (float j = 0; j <= height; j += 20) {
      //computes the distance from each new ellipse to the mouse
      mouseDist = dist(mouseX, mouseY, i, j);
      //diameter of the ellipse is determined by dividing the distance to the mouse
      //by the maxDistance we found above
      //then, in order to have the pulsing, multiply by a cos() that uses k,i, and j
      diameter = (mouseDist / maxDistance) * cos(k+i/300-j/200) * 30;
      //makes the color change according to mouse y, the distance to the mouse, and pulse with a sin()
      fill(mouseY/2, mouseDist, sin(k)* 100);
      //actually draws the ellipse
      ellipse(i, j, diameter, diameter);
    }
  }
}
